# This module looks for the Dot tool from the GraphViz package (see http://www.graphviz.org)
# It defines:
#   DOT_TOOL      : the result data
#   DOT_FOUND     : yes if the tool was found
#   DOT_TOOL_PATH : full path to the Dot tool (dot.exe)

IF(WIN32)

	FIND_PROGRAM( 
		DOT_TOOL
		NAMES dot
		PATHS
			[HKEY_LOCAL_MACHINE\\SOFTWARE\\AT&T Research Labs\\Graphviz;InstallPath]/bin
			"$ENV{ProgramFiles}/Graphviz 2.21/bin"
			"$ENV{ProgramFiles}/Graphviz2.26.3/bin"
			"$ENV{ProgramFiles}/ATT/Graphviz/bin"
	    DOC "Graphviz's Dot tool"
	)
	
	GET_FILENAME_COMPONENT(DOT_TOOL_PATH "${DOT_TOOL}" PATH)
	IF( DOT_TOOL )
		message( STATUS "Dot found ")
		set( DOT_FOUND yes )
	ELSE()
		message( STATUS "Dot not found ")	
	ENDIF()
	
	MARK_AS_ADVANCED(
		DOT_TOOL
    )

ENDIF()
