# - This module looks for the Highligh tools (see www.andre-simon.de)
# It defines:
#   HIGHLIGHT_TOOL      : result data
#   HIGHLIGHT_FOUND     : yes if Highlight tool was found
#   HIGHLIGHT_TOOL_PATH : full path to the Highligher tool (highlight.exe)

IF(WIN32)

	FIND_PROGRAM(
		HIGHLIGHT_TOOL
		NAMES highlight
		PATHS
			"$ENV{ProgramFiles}/WinHighlight"
		DOC "Syntax highligting tool"
	)
	
	GET_FILENAME_COMPONENT(HIGHLIGHT_TOOL_PATH "${HIGHLIGHT_TOOL}" PATH)
	IF( HIGHLIGHT_TOOL )
		message( STATUS "Highlight found ")
		set( HIGHLIGHT_FOUND yes )
	ELSE()
		message( STATUS "Highlight not found ")	
	ENDIF()
	
	MARK_AS_ADVANCED(
		HIGHLIGHT_TOOL
    )

ENDIF(WIN32)
