#!/bin/bash
#
# run the unit tests of the genicam project
#

export GENICAM_ROOT_V2_3=$PWD
export GENICAM_CACHE_V2_3=/var/tmp
export GENICAM_LOG_CONFIG_V2_3=$GENICAM_ROOT_V2_3/log/config-unix/TestLogging.properties

function Usage
{
  echo "Usage: $0 Maci64_x64|Linux64_x64|Linux32_i86|Linux32_ARM [testcase]"
  exit 1
}

if [ $# -lt 1 ]; then
  Usage
fi

export genicamarch=$1
shift

if [ "x$genicamarch" == "xMaci64_x64" ]
then
    shlibsuffix=.dylib
elif [ "x$genicamarch" == "xLinux64_x64" \
     -o "x$genicamarch" == "xLinux32_i86" \
     -o "x$genicamarch" == "xLinux32_ARM" ]
then
    shlibsuffix=.so
else
    Usage
fi
export shlibsuffix

export builddir=$GENICAM_ROOT_V2_3/build_$genicamarch

export PATH=$GENICAM_ROOT_V2_3/bin/$genicamarch:$PATH
export TEST_RESULT_FILE=$builddir/GenApiTest_Release.log
export xml_result_file=$builddir/GenApiTest_Release.xml

[ -d "$builddir" ] || mkdir "$builddir" || \
    { echo "Error: Failed creating \"$builddir\""; exit 1; }

rm -f $xml_result_file

if [    "xRelease" == "xrelease" \
     -o "xRelease" == "xRelease" ]
then
DllPluginTester_gcc42_v2_3  libGenApiTest_gcc42_v2_3$shlibsuffix $*
else
DllPluginTester_d_gcc42_v2_3  libGenApiTest_d_gcc42_v2_3$shlibsuffix $*
fi

state=$?

awk -f test2xml.awk $TEST_RESULT_FILE > $xml_result_file
tail $TEST_RESULT_FILE

exit $state
