//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Hartmut Nebelung
//  $Header$
//-----------------------------------------------------------------------------
/*!
  \file
  Helper object for testing callbacks
*/
#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _CALLBACKHELPER_H_
#define _CALLBACKHELPER_H_

#include "GenApi/INode.h"

// ---------------------------------------------------------------------------
// a callback object
// ---------------------------------------------------------------------------
class CallbackObject
{
public:
    CallbackObject() :
        m_Count(0)
    {}
    void Reset()
    {
        m_Count = 0;
    }
    uint32_t Count() const
    {
        return m_Count;
    }
    void Callback( GenApi::INode* )
    {
        ++m_Count;
    }
private:
    uint32_t m_Count;
};

#endif // _CALLBACKHELPER_H_
