//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/

#ifdef _MSC_VER
#   include "GenApi/impl/GlobalPragmas.h"  // this must be the first include!
#endif

#include "GenApiTest.h"
#include "CycleDetectorTest.h"
#include "GenApi/GenApi.h"


using namespace std;
using namespace GenICam;
using namespace GenApi;

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( CycleDetectorTestSuite, "GenApiTest");


void CycleDetectorTestSuite::TestWriteCycles()
{
    CNodeMapRef Camera;
    gcstring XMLFileName;

    // make sure the test is reproducible
    CNodeMapRef::_ClearXMLCache();

    // Load check a file with a write cycle and a top level node
    XMLFileName = XMLPATH "Test/TestCamera_WriteCycle_1.xml";
    CPPUNIT_ASSERT_THROW_EX( Camera._PreprocessXMLFromFile( XMLFileName, "", "", xvCycles ), GenICam::RuntimeException);

    // Load check a file with a write cycle and no top level node
    XMLFileName = XMLPATH "Test/TestCamera_WriteCycle_2.xml";
    CPPUNIT_ASSERT_THROW_EX( Camera._PreprocessXMLFromFile( XMLFileName, "", "", xvCycles ), GenICam::RuntimeException);

    // Load check a file with a no cycle
    XMLFileName = XMLPATH "Test/TestCamera_NoCycle.xml";
    CPPUNIT_ASSERT_NO_THROW( Camera._PreprocessXMLFromFile( XMLFileName, "", "", xvCycles ));
}

void CycleDetectorTestSuite::TestDependencyCycles()
{
    CNodeMapRef Camera;
    gcstring XMLFileName;

    // make sure the test is reproducible
    CNodeMapRef::_ClearXMLCache();

    // Load check a file with a write cycle and a top level node
    XMLFileName = XMLPATH "Test/TestCamera_DependencyCycle_1.xml";
    CPPUNIT_ASSERT_THROW_EX( Camera._PreprocessXMLFromFile( XMLFileName, "", "", xvCycles ), GenICam::RuntimeException);

    // Load check a file with a write cycle and no top level node
    XMLFileName = XMLPATH "Test/TestCamera_DependencyCycle_2.xml";
    CPPUNIT_ASSERT_THROW_EX( Camera._PreprocessXMLFromFile( XMLFileName, "", "", xvCycles ), GenICam::RuntimeException);
}
