//-----------------------------------------------------------------------------
//  (c) 2006 by Basler Vision Technologies
//  Section:  Vision Components
//  Project:  GenApi
//    Author:  Fritz Dierks
//  $Header$
//
//  License: This file is published under the license of the EMVA GenICam  Standard Group.
//  A text file describing the legal terms is included in  your installation as 'GenICam_license.pdf'.
//  If for some reason you are missing  this file please contact the EMVA or visit the website
//  (http://www.genicam.org) for a full copy.
//
//  THIS SOFTWARE IS PROVIDED BY THE EMVA GENICAM STANDARD GROUP "AS IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
//  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
//  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE EMVA GENICAM STANDARD  GROUP
//  OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  SPECIAL,
//  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT  LIMITED TO,
//  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,  DATA, OR PROFITS;
//  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY  THEORY OF LIABILITY,
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT  (INCLUDING NEGLIGENCE OR OTHERWISE)
//  ARISING IN ANY WAY OUT OF THE USE  OF THIS SOFTWARE, EVEN IF ADVISED OF THE
//  POSSIBILITY OF SUCH DAMAGE.
//-----------------------------------------------------------------------------
/**
\file
\brief    Implementation of DLLMain .
*/

#if defined (_WIN32)

#include "GenApi/impl/GlobalPragmas.h"  // this must be the first include!
#include <windows.h>
#include "GenApiTestPlugIn.h"
#include "GenApi/GenApi.h"
#include "GenApi/DLLLoad.h"
#include "GenApiTest.h"

#if defined _WIN32 && defined _MT
#   pragma comment(lib, LIB_NAME( "Cppunit" ))
#   pragma comment(lib, LIB_NAME( "Log4cpp" ))
#   pragma comment(lib, LIB_NAME( "Log" ))
#   pragma comment(lib, LIB_NAME( "GenApi" ))
#   pragma comment(lib, LIB_NAME( "GCBase" ))
#endif


//! Global instance handle
HINSTANCE g_hInst;

//CPPUNIT_PLUGIN_EXPORTED_FUNCTION_IMPL( CPPUNIT_NS::TestPlugInDefaultImpl );
CPPUNIT_PLUGIN_EXPORTED_FUNCTION_IMPL( TestPlugInImpl );

extern "C" BOOL WINAPI DllMain(
    HINSTANCE hInstDll,
    DWORD fdwReason,
    LPVOID /*lpvReserved*/ )
{
    static __int32 iFirstCall = 0;

    g_hInst = hInstDll;

    switch (fdwReason)
    {
    case DLL_PROCESS_ATTACH:
        if (!iFirstCall)
        {
            iFirstCall++;
            // initilize global things here

            // Make sure we get defined initial conditions for the tests
            GenApi::CNodeMapRef::_ClearXMLCache();

        }
        break;

    case DLL_THREAD_ATTACH:
        break;

    case DLL_THREAD_DETACH:
        break;

    case DLL_PROCESS_DETACH:
        iFirstCall--;
        if (!iFirstCall)
        {
            // de-initilize global things here
            GenApi::GenApiTerminate();
        }
        break;
    }
    return true;
}

#elif defined (__GNUC__) && (defined (__linux__) || defined (__APPLE__))
//#include <cppunit/plugin/TestPlugIn.h>
#include "GenApi/NodeMapRef.h"
#include "GenApiTestPlugin.h"

CPPUNIT_PLUGIN_EXPORT CppUnitTestPlugIn *CPPUNIT_PLUGIN_EXPORTED_NAME(void) __attribute__ ((visibility("default")));
//CPPUNIT_PLUGIN_EXPORTED_FUNCTION_IMPL( CPPUNIT_NS::TestPlugInDefaultImpl );
CPPUNIT_PLUGIN_EXPORTED_FUNCTION_IMPL( TestPlugInImpl );

extern "C" {
    void dllinit(void) __attribute__((constructor));

    void dllinit(void)
    {
        GenApi::CNodeMapRef::_ClearXMLCache();
    }
}
#else
#   error No/unknown support for shared libraries
#endif
