//-----------------------------------------------------------------------------
//  (c) 2006 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Hartmut Nebelung
//  $Header$
//-----------------------------------------------------------------------------
/*!
  \file
  Test the implementation of Node dependencies
*/
#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _DEPENDENCYTESTSUITE_H_
#define _DEPENDENCYTESTSUITE_H_

#include "GenApiTest.h"

class DependencyTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( DependencyTestSuite );
        CPPUNITEX_TEST( TestDependency01 );
        CPPUNITEX_TEST( TestDependency02 );
        CPPUNITEX_TEST( TestDependency03 );
        CPPUNITEX_TEST( TestDependency04 );
        CPPUNITEX_TEST( TestDependency05 );
        CPPUNITEX_TEST( TestDependency06 );
        CPPUNITEX_TEST( TestDependency07 );
        CPPUNITEX_TEST( TestDependency08 );
        CPPUNITEX_TEST( TestDependency09 );
        CPPUNITEX_TEST( TestDependency10 );
        CPPUNITEX_TEST( TestDependency11 );
        CPPUNITEX_TEST( TestDependency12 );
        CPPUNITEX_TEST( TestDependency13 );
        CPPUNITEX_TEST( TestDependency14 );
        CPPUNITEX_TEST( DependencyDump );
    CPPUNIT_TEST_SUITE_END();

public:
    // register types
    // ----------------------------------------
    void TestDependency01();
    void TestDependency02();
    void TestDependency03();
    void TestDependency04();
    void TestDependency05();
    // misc types
    // ----------------------------------------
    void TestDependency06();
    void TestDependency07();
    void TestDependency08();
    void TestDependency09();
    // feature types: integer, float, string, ...
    // ----------------------------------------
    void TestDependency10();
    void TestDependency11();
    void TestDependency12();
    void TestDependency13();
    void TestDependency14();

    // Dumps nodes from all XML files lodated in $(GENICAM_ROOT)/xml/GenApi/Test/Performance
    // with their dependencies in a systematic way
    void DependencyDump();
};
#endif // _DEPENDENCYTESTSUITE_H_
