//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------

/*!
\file
*/

#ifdef _MSC_VER
#   include "GenApi/impl/GlobalPragmas.h"  // this must be the first include!
#endif

#include "GenApiTest.h"
#include "GenApiTestPlugin.h"
#include "Base/GCString.h"

TestPlugInImpl::TestPlugInImpl() 
{}

TestPlugInImpl::~TestPlugInImpl()
{}

void TestPlugInImpl::initialize( CPPUNIT_NS::TestFactoryRegistry * /*registry*/,
                                const CPPUNIT_NS::PlugInParameters &parameters )
{
    std::string CommandLineParamter = parameters.getCommandLine();
    if( ! EGenApiSchemaVersionClass::FromString( CommandLineParamter, &GenApiSchemaVersion ) )
        GenApiSchemaVersion = v1_1; // default

    switch(GenApiSchemaVersion)
    {
    case v1_0:
        CDFHeader =
                "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"
                "<RegisterDescription\n"
                "      ModelName=\"GenApiTest\"\n"
                "      VendorName=\"Generic\"\n"
                "      ToolTip=\"nodes for testing the GenApi reference implementation\"\n"
                "      StandardNameSpace=\"GEV\"\n"
                "      SchemaMajorVersion=\"1\"\n"
                "      SchemaMinorVersion=\"0\"\n"
                "      SchemaSubMinorVersion=\"1\"\n"
                "      MajorVersion=\"2\"\n"
                "      MinorVersion=\"3\"\n"
                "      SubMinorVersion=\"4\"\n"
                "      ProductGuid=\"2D932CC6-EB68-40bd-B6CC-F03B55B7D653\"\n"
                "      VersionGuid=\"02A8C268-BEE8-463b-A6C0-53ED8256E3D8\"\n"
                "      xmlns=\"http://www.genicam.org/GenApi/Version_1_0\"\n"
                "      xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
                "      xsi:schemaLocation=\"http://www.genicam.org/GenApi/Version_1_0"
                "            http://www.genicam.org/GenApi/GenApiSchema_Version_1_0.xsd\">\n";

        break;

    case v1_1:
        CDFHeader =
                "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"
                "<RegisterDescription\n"
                "      ModelName=\"GenApiTest\"\n"
                "      VendorName=\"Generic\"\n"
                "      ToolTip=\"nodes for testing the GenApi reference implementation\"\n"
                "      StandardNameSpace=\"GEV\"\n"
                "      SchemaMajorVersion=\"1\"\n"
                "      SchemaMinorVersion=\"1\"\n"
                "      SchemaSubMinorVersion=\"0\"\n"
                "      MajorVersion=\"2\"\n"
                "      MinorVersion=\"3\"\n"
                "      SubMinorVersion=\"4\"\n"
                "      ProductGuid=\"2D932CC6-EB68-40bd-B6CC-F03B55B7D653\"\n"
                "      VersionGuid=\"02A8C268-BEE8-463b-A6C0-53ED8256E3D8\"\n"
                "      xmlns=\"http://www.genicam.org/GenApi/Version_1_1\"\n"
                "      xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
                "      xsi:schemaLocation=\"http://www.genicam.org/GenApi/Version_1_1"
                "            http://www.genicam.org/GenApi/GenApiSchema_Version_1_1.xsd\">\n";

        break;

    default:
        assert(false);
    }

    CDFFooter = "</RegisterDescription>\n";

}


