//-----------------------------------------------------------------------------
//  (c) 2008 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __INDEXEDFLOATTEST_H
#define __INDEXEDFLOATTEST_H

#include "GenApiTest.h"

/**
\brief Tests Float
*/
class IndexedFloatTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( IndexedFloatTestSuite );
        CPPUNITEX_TEST( TestMultiplexerMode );
        CPPUNITEX_TEST( TestPolymorphicalFloatAccess );
        CPPUNITEX_TEST( TestIndexedAccess );
        CPPUNITEX_TEST( TestAccessMode );
		CPPUNITEX_TEST( TestTicket803 );
    CPPUNIT_TEST_SUITE_END();

public:
    //! tests the multiplexer functionality
    void TestMultiplexerMode();

    //! Tests the PolyPointer inside the Float node
    void TestPolymorphicalFloatAccess();

    //! Tests the indexed access
    void TestIndexedAccess();

    //! Tests the access mode
    void TestAccessMode();

	void TestTicket803();
};

#endif // __INDEXEDFLOATTEST_H
