//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __INDEXEDINTEGERTEST_H
#define __INDEXEDINTEGERTEST_H

#include "GenApiTest.h"

/**
\brief Tests CIntReg
*/
class IndexedIntegerTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( IndexedIntegerTestSuite );
        CPPUNITEX_TEST( TestMultiplexerMode );
        CPPUNITEX_TEST( TestPolymorphicalIntegerAccess );
        CPPUNITEX_TEST( TestIndexedAccess );
        CPPUNITEX_TEST( TestAccessMode );
		CPPUNITEX_TEST( Test_803 );
        CPPUNITEX_TEST( TestNumberOfCallbacks01 );
        CPPUNITEX_TEST( TestNumberOfCallbacks02 );
        CPPUNITEX_TEST( TestNumberOfCallbacks03 );
        CPPUNITEX_TEST( TestIgnoreCache );
        CPPUNITEX_TEST( TestGetProperty );
    CPPUNIT_TEST_SUITE_END();

public:
    //! tests the multiplexer functionality
    void TestMultiplexerMode();

    //! Tests the PolyPointer inside the Integer node
    void TestPolymorphicalIntegerAccess();

    //! Tests the indexed access
    void TestIndexedAccess();

    //! Tests the access mode
    void TestAccessMode();

	//! This reproduces issued in https://genicam.mvtec.com/trac/genicam/ticket/803
	void Test_803();

    //! Tests number of callbacks for multiplexer nodes
    void TestNumberOfCallbacks01();

    //! Tests number of callbacks for polling nodes
    void TestNumberOfCallbacks02();

    //! Tests number of callbacks for IsDone on multiplexer nodes
    void TestNumberOfCallbacks03();

    //! Tests if IgnoreCache invalidates dependent nodes
    void TestIgnoreCache();

    //! Tests if we can read the property even if they are not initialized.
    void TestGetProperty();

};

#endif // __INDEXEDINTEGERTEST_H
