//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __INTREGTEST_H
#define __INTREGTEST_H

#include "GenApiTest.h"

/**
\brief Tests CIntReg
*/
class IntRegTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( IntRegTestSuite );
        CPPUNITEX_TEST( TestValueAccess );
        CPPUNITEX_TEST( TestpLength );
        CPPUNITEX_TEST( TestpLengthThroughReg );
        CPPUNITEX_TEST( TestRegOverlap );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests the basic get and set methods
    void TestValueAccess();
    //! Test the pLength functionality
    void TestpLength();
    //! Test the pLength pointing to camera (not floating) register
    void TestpLengthThroughReg();
    //! Tests registers with overlapping address
    void TestRegOverlap();

};

#endif // __INTREGTEST_H
