//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __INTEGERREPLICATORTEST_H
#define __INTEGERREPLICATORTEST_H

#include "GenApiTest.h"

/**
\brief Tests replicator functionality of the integer node
*/
class IntegerReplicatorTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( IntegerReplicatorTestSuite );
        CPPUNITEX_TEST( TestUseCase2 );
        CPPUNITEX_TEST( TestUseCase1 );
        CPPUNITEX_TEST( TestValueAccess );
        CPPUNITEX_TEST( TestMinMaxHandling );
        CPPUNITEX_TEST( TestIncHandling );
        CPPUNITEX_TEST( TestCallbacks );
        CPPUNITEX_TEST( TestAccessMode );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Implements a simple example
    void TestUseCase1();

    //! Implements another simple example
    void TestUseCase2();

    //! Tests the basic get and set methods
    void TestValueAccess();

    //! Tests the handling of GetMin and GetMax
    void TestMinMaxHandling();

    //! Tests the handling of GetInc
    void TestIncHandling();

    //! Tests the handling of callbacks
    void TestCallbacks();

    //! Tests access mode handling
    void TestAccessMode();

};

#endif // __INTEGERREPLICATORTEST_H
