//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef _MASKEDINTREGTEST_H
#define _MASKEDINTREGTEST_H

#include "GenApiTest.h"

/**
\brief Tests CMaskedIntReg
*/
class MaskedIntRegTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( MaskedIntRegTestSuite );
        CPPUNITEX_TEST( TestValueAccess );
        CPPUNITEX_TEST( TestMaskedIntReg01 );
        CPPUNITEX_TEST( TestMaskedIntReg02 );
        CPPUNITEX_TEST( TestMaskedIntReg03 );
        CPPUNITEX_TEST( TestMaskedIntReg04 );
        CPPUNITEX_TEST( TestMaskedIntReg05 );
        CPPUNITEX_TEST( TestMaskedIntReg06 );
        //! Test Signed value with full data range
        CPPUNITEX_TEST( TestMaskedIntReg07 );
        //! Test no Endianess defined
        CPPUNITEX_TEST( TestMaskedIntReg08 );
        CPPUNITEX_TEST( TestCornerCases );
		CPPUNITEX_TEST( TestTicket703 );

    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests the basic get and set methods
    void TestValueAccess();
    void TestMaskedIntReg01();
    void TestMaskedIntReg02();
    void TestMaskedIntReg03();
    void TestMaskedIntReg04();
    void TestMaskedIntReg05();
    void TestMaskedIntReg06();
    void TestMaskedIntReg07();
    void TestMaskedIntReg08();
    void TestCornerCases();

	//! see https://genicam.mvtec.com/trac/genicam/ticket/703
	void TestTicket703();
};

#endif // _MASKEDINTREGTEST_H
