//-----------------------------------------------------------------------------
//  (c) 2010 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
  \file
  Test the implementation of Persistence
*/
#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _NODEMAPPERSISTENCETESTSUITE_H_
#define _NODEMAPPERSISTENCETESTSUITE_H_

#include "GenApiTest.h"

class NodeMapPersistenceTestSuite : public CPPUNIT_NS::TestCaseEx
{
     CPPUNIT_TEST_SUITE( NodeMapPersistenceTestSuite );
        CPPUNITEX_TEST( TestSimple );
		CPPUNITEX_TEST( TestSelector );
		CPPUNITEX_TEST( TestAccessMode );
		CPPUNITEX_TEST( TestMisc );
		CPPUNITEX_TEST( TestEnumerationSelector );
		CPPUNITEX_TEST( TestEnumerationSelectorSelector );
		CPPUNITEX_TEST( TestRecursionBreaker );
		CPPUNITEX_TEST( TestSelectorNotImplemented_1 );
		CPPUNITEX_TEST( TestSelectorNotImplemented_2 );
        CPPUNITEX_TEST( TestSelectorNotImplemented_3 );
        CPPUNITEX_TEST( TestSelectorNotImplemented_4 );
        CPPUNITEX_TEST( TestSelectorNotImplemented_5 );
        CPPUNITEX_TEST( TestSelectorNotImplemented_6 );
        CPPUNITEX_TEST( TestSelectorNotImplemented_7 );
		CPPUNITEX_TEST( TestMaxNumPersistSkriptEntries );
    CPPUNIT_TEST_SUITE_END();

public:
  void TestSimple();
  void TestSelector();
  void TestAccessMode();
  void TestMisc();
  void TestEnumerationSelector();
  void TestEnumerationSelectorSelector();
  void TestRecursionBreaker();
  void TestSelectorNotImplemented_1();
  void TestSelectorNotImplemented_2();
  void TestSelectorNotImplemented_3();
  void TestSelectorNotImplemented_4();
  void TestSelectorNotImplemented_5();
  void TestSelectorNotImplemented_6();
  void TestSelectorNotImplemented_7();
  void TestMaxNumPersistSkriptEntries();

};

#endif 
