//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __PERFORMANCETEST_H
#define __PERFORMANCeTEST_H

#include "GenApiTest.h"

/**
\brief Tests the performance of GenApi
*/
class PerformanceTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( PerformanceTestSuite );
        CPPUNITEX_TEST( TestStopWatch );
        CPPUNITEX_TEST( TestIntReg );
        CPPUNITEX_TEST( TestDcamScalar );
        CPPUNITEX_TEST( TestXMLLoading );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests the timer itself
    void TestStopWatch();

    //! Tests the performance of the IntReg node
    void TestIntReg();

    //! Tests DCAM scalar feature
    void TestDcamScalar();

    //! Tests the loading of an XML file
    void TestXMLLoading();
};

#endif // __PERFORMANCETEST_H
