//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __REGISTERTEST_H
#define __REGISTERTEST_H

#include "GenApiTest.h"

/**
\brief Tests CRegister
*/
class RegisterTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( RegisterTestSuite );
        CPPUNITEX_TEST( TestValueAccessSwiss );
        CPPUNITEX_TEST( TestValueAccessIndex );
        CPPUNITEX_TEST( TestValueAccessIndexPOffset );
        CPPUNITEX_TEST( TestValueAccessIndexNoOffset );
        CPPUNITEX_TEST( TestValueAccess );
        CPPUNITEX_TEST( TestEmbeddedSwissKnife );
        CPPUNITEX_TEST( TestEmbeddedSwissKnife2 );
        CPPUNITEX_TEST( TestRegisterNode );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests the basic get and set methods with Swiss Knife
    void TestValueAccessSwiss();

    //! Tests the basic get and set methods with Index
    void TestValueAccessIndex();

    //! Tests the basic get and set methods with Index and pOffset
    void TestValueAccessIndexPOffset();

    //! Tests the basic get and set methods with Index and no Offset/pOffset
    void TestValueAccessIndexNoOffset();

    //! Tests the basic get and set methods
    void TestValueAccess();

    //! Mantis #98
    void TestEmbeddedSwissKnife();

    void TestEmbeddedSwissKnife2();

    void TestRegisterNode();
};

#endif // __REGISTERTEST_H
