//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Hartmut Nebelung
//  $Header$
//-----------------------------------------------------------------------------
/*!
  \file
  Test the implementation of ISelector
*/
#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _SELECTORSETTESTSUITE_H_
#define _SELECTORSETTESTSUITE_H_

#include "GenApiTest.h"

class SelectorSetTestSuite : public CPPUNIT_NS::TestCaseEx
{
     CPPUNIT_TEST_SUITE( SelectorSetTestSuite );
        CPPUNITEX_TEST( TestParallelSelectors );
        CPPUNITEX_TEST( TestSequentialSelectors );
        CPPUNITEX_TEST( TestRealWordLUT );
        CPPUNITEX_TEST( TestSelectorTree );
        CPPUNITEX_TEST( TestSelectorRing );
        CPPUNITEX_TEST( TestNotAvailableEnum );
        CPPUNITEX_TEST( InvalidSelector );
        CPPUNITEX_TEST( SelectorWithoutValues );
        CPPUNITEX_TEST( RestoreSelector );
        CPPUNITEX_TEST( TestRecursionBreaker );
        CPPUNITEX_TEST( SelectorNotImplemented );
        CPPUNITEX_TEST( TestRestoreSelectorNotAvailableEnum );
    CPPUNIT_TEST_SUITE_END();

public:
  void TestParallelSelectors();
  void TestSequentialSelectors();
  void TestRealWordLUT();
  void TestSelectorTree();
  void TestSelectorRing();
  void TestNotAvailableEnum();
  void InvalidSelector();
  void SelectorWithoutValues();
  void RestoreSelector();
  void TestRecursionBreaker();
  void SelectorNotImplemented();
  void TestRestoreSelectorNotAvailableEnum();
};

#endif 
