//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/

#ifndef __TESTREGISTERPORT_H
#define __TESTREGISTERPORT_H

#include "GenApiTest.h"
#include "GenApi/RegisterPortImpl.h"
#include "RegisterMap.h"

/**
\brief Dummy Register Port for testing nodes
*/
class CTestRegisterPort : public CRegisterMap, public GenApi::CRegisterPortImpl
{
public:
    CTestRegisterPort(int MaxNumQuadlets = 1, bool TransportLayerSwapsEndianess = false) :
        CRegisterPortImpl(MaxNumQuadlets, TransportLayerSwapsEndianess)
    {
    }

   //-------------------------------------------------------------
    // IBase implementation
    //-------------------------------------------------------------

    //! Get the access mode of the node
    virtual GenApi::EAccessMode GetAccessMode() const;

    //! Get the type of the main interface of a node
    virtual GenApi::EInterfaceType GetPrincipalInterfaceType() const;

    //---------------------------------------------------------------
    // RegisterPort implementation
    //---------------------------------------------------------------

    //! Reads a array of quadlets from the port
    virtual void ReadRegister(uint32_t *pRegisters, int64_t Address, int64_t Length);

    //! Writes an array of quadlets to the port
    virtual void WriteRegister(const uint32_t *pRegisters, int64_t Address, int64_t Length);

};

#endif // __TESTREGISTERPORT_H
