//-----------------------------------------------------------------------------
//  (c) 2005 by Basler Vision Technologies
//  Section: Vision Components
//  Project: GenApiTest
//    Author:  Fritz Dierks
//  $Header$
//-----------------------------------------------------------------------------
/*!
\file
*/


#ifndef __UTILITIESTEST_H
#define __UTILITIESTEST_H

#include "GenApiTest.h"

/**
\brief Tests GenApi utilities
*/
class UtilitiesTestSuite : public CPPUNIT_NS::TestCaseEx
{
    CPPUNIT_TEST_SUITE( UtilitiesTestSuite );
        CPPUNITEX_TEST( TestReplaceEnvironmentVariable );
        CPPUNITEX_TEST( TestString2Value );
        CPPUNITEX_TEST( TestEAccessModeClass );
        CPPUNITEX_TEST( TestECachingModeClass );
        CPPUNITEX_TEST( TestESignClass );
        CPPUNITEX_TEST( TestEEndianessClass );
        CPPUNITEX_TEST( TestENameSpaceClass );
        CPPUNITEX_TEST( TestERepresentationClass );
        CPPUNITEX_TEST( TestEVisibilityClass );
        CPPUNITEX_TEST( TestEYesNoClass );
        CPPUNITEX_TEST( TestEStandardNameSpaceClass );
        CPPUNITEX_TEST( TestSyncClasses );
        CPPUNITEX_TEST( TestGlobalLock );
        CPPUNITEX_TEST( TestOpOnNodeVectors );
        CPPUNITEX_TEST( TestGetInterfaceName );
        CPPUNITEX_TEST( TestMiscellaneous );
        CPPUNITEX_TEST( TestMissingRoot );
        CPPUNITEX_TEST( TestEDisplayNotationClass );
        CPPUNITEX_TEST( TestURLEscape );
    CPPUNIT_TEST_SUITE_END();

public:
    //! Tests the function GenApi::ReplaceEnvironmentVariable
    void TestReplaceEnvironmentVariable();

    //! Tests the functions Value2String and String2Value
    void TestString2Value();

    /// Test EAccessModeClass
    void TestEAccessModeClass();

    /// Test ECachingModeClass
    void TestECachingModeClass();

    /// Test ESignClass
    void TestESignClass( void );

    /// Test EEndianessClass
    void TestEEndianessClass( void );

    /// Test TestENamespaceClass
    void TestENameSpaceClass( void );

    /// Test TestERepresentationClass
    void TestERepresentationClass( void );

    /// Test TestEVisibilityClass
    void TestEVisibilityClass( void );

    /// Test TestEYesNoClass
    void TestEYesNoClass( void );

    /// Test TestEStandardNameSpaceClass
    void TestEStandardNameSpaceClass( void );

    /// Test TestAutoLockClass
    void TestSyncClasses( void );

    /// Test Operation on Node Vectors
    void TestOpOnNodeVectors( void );

    /// Tests function TestGetInterfaceName
    void TestGetInterfaceName( void );

    /// Test Miscellaneous Apis
    void TestMiscellaneous( void );

    /// Test missing genicam root variable
    void TestMissingRoot( void );

    /// Test TestEDisplayNotationClass
    void TestEDisplayNotationClass( void );

    /// Test TestURLEscape
    void TestURLEscape( void );

    /// Test GlobalLock (for MD config only)
    void TestGlobalLock( void );

protected:
#ifdef _WIN32
    static unsigned __stdcall TestLockThread(void* p);
#else
    static void* TestLockThread(void* p);
#endif

};

#endif // __UTILITIESTEST_H
